package rm;

import java.math.BigInteger;
import java.util.Arrays;

import static rm.Halt.HALT;

/* Contains some simple examples of RM programs and their executions. */
public class Examples {

	/* Auxiliary functions to make writing of the code a bit more readable. */
	private static AddOne ADD(int reg, int jumpLabel) {
		return new AddOne(reg, jumpLabel);
	}
	private static SubOne SUB(int reg, int posLabel, int zeroLabel) {
		return new SubOne(reg, posLabel, zeroLabel);
	}
	private static int L(int l) {
		return l;
	}
	private static int R(int r) {
		return r;
	}
	private static final boolean doNotAllowErroneousHalts = false; 
	
	public static void addExample() {
		Program program = new Program(Arrays.asList(
				SUB(R(1), L(1), L(2)),
				ADD(R(0), L(0)),
				SUB(R(2), L(3), L(4)),
				ADD(R(0), L(2)),
				HALT
				), doNotAllowErroneousHalts);
		RegisterMachine rm = new RegisterMachine();
		rm.setDebug(true);
		RegisterConfiguration config = new RegisterConfiguration(3);
		config.setRegister(1, BigInteger.valueOf(4));
		config.setRegister(2, BigInteger.valueOf(2));
		rm.execute(program, config);
		System.out.println(config);
	}
	
	public static void copyExample() {
		Program program = new Program(Arrays.asList(
				SUB(R(0), L(0), L(1)),
				SUB(R(2), L(1), L(2)),
				SUB(R(1), L(3), L(5)),
				ADD(R(0), L(4)),
				ADD(R(2), L(2)),
				SUB(R(2), L(6), L(7)),
				ADD(R(1), L(5)),
				HALT
				), doNotAllowErroneousHalts);
		RegisterMachine rm = new RegisterMachine();
		rm.setDebug(true);
		RegisterConfiguration config = new RegisterConfiguration(3);
		config.setRegister(0, BigInteger.valueOf(8));
		config.setRegister(1, BigInteger.valueOf(10));
		config.setRegister(2, BigInteger.valueOf(2));
		rm.execute(program, config);
		System.out.println(config);
	}
	
	public static void main(String[] args) {
		System.out.println("Copy example:");
		copyExample();
		System.out.println("Add example:");
		addExample();
	}
	
}
