package rm;

import java.util.Collections;
import java.util.List;

/* The HALT instruction. Jumps to a halt label. */
public class Halt implements Instruction {

	public static final Halt HALT = new Halt();
	
	/* There is a unique halt instruction. */
	private Halt() { }
	
	@Override
	public Label execute(RegisterConfiguration config) {
		return HaltLabel.HALT;
	}

	@Override
	public List<Label> getAccessingLabels() {
		return Collections.emptyList();
	}

	@Override
	public List<Integer> getAccessingRegisters() {
		return Collections.emptyList();
	}

}
