package rm;

import java.util.List;

/* RM instruction interface. */
public interface Instruction {

	/* Execute the instruction given the configuration and return next label. */
	public Label execute(RegisterConfiguration config);
	
	/* 
	 * Returns the labels that the instruction could access. 
	 * Used only for finding mistakes in code.
	 */
	public List<Label> getAccessingLabels();
	
	/*
	 * Returns the registers accessed by this instruction.
	 * Used only for finding mistakes in code.
	 */
	public List<Integer> getAccessingRegisters();
	
}
