package rm;

import java.math.BigInteger;

/* 
 * Keeps the contents of the registers for the current execution. 
 * 
 * In the course, this was defined to also include the current label.
 */
public class RegisterConfiguration {
	
	private final BigInteger[] registers;
	
	public RegisterConfiguration(int numRegisters) {
		this.registers = new BigInteger[numRegisters];
		for (int i = 0; i < numRegisters; ++i) {
			this.registers[i] = BigInteger.valueOf(0);
		}
	}
	
	public void setRegister(int registerId, BigInteger value) {
		registers[registerId] = value;
	}
	
	public BigInteger getRegister(int registerId) {
		return registers[registerId];
	}
	
	public int getNumRegisters() {
		return registers.length;
	}
	
	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder("[");
		for (int i = 0; i < registers.length; ++i) {
			builder.append("R").append(i).append('=').append(registers[i]).append(';');
		}
		builder.append(']');
		return builder.toString();
	}

}
